'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _readlineSync = require('readline-sync');

var _readlineSync2 = _interopRequireDefault(_readlineSync);

var _logUpdate = require('log-update');

var _logUpdate2 = _interopRequireDefault(_logUpdate);

var _utilsLoadData = require('./utils/loadData');

var _utilsLoadData2 = _interopRequireDefault(_utilsLoadData);

// Clear CLI
process.stdout.write('\u001b[2J\u001b[0;0H');
// Print a header
console.log(_chalk2['default'].black.bgYellow('                    MVG                     '));

var startStation = undefined;

if (process.argv && process.argv[2]) {
  startStation = process.argv[2];
} else {
  startStation = _readlineSync2['default'].question('From what station do you want to start? : ');
}

console.log(_chalk2['default'].yellow('Show all trips from ' + _chalk2['default'].yellow.underline(startStation)));

var LiveData = [];
var LastRefresh = +new Date();

var updateData = function updateData() {
  (0, _utilsLoadData2['default'])({
    station: startStation
  }, function (err, data) {
    if (err) throw 'Error: ' + err;
    LiveData = data;
    LastRefresh = +new Date();
  });
};
String.prototype.paddingLeft = function (paddingValue) {
  return String(paddingValue + this).slice(-paddingValue.length);
};

updateData();

setInterval(function () {
  updateData();
}, 5000);

var tmpl = '';
setInterval(function () {
  if (LiveData.length > 0) {
    (function () {
      var deps = [];

      // console.log(LiveData.departures);

      LiveData.departures.map(function (dep) {
        deps.push(' ' + _chalk2['default'].white.bgRed(dep.route.paddingLeft("   ") + " ") + ' in ' + dep.arrivingIn.paddingLeft("  ") + ' minutes to ' + dep.station + '\n');
      });

      tmpl = '\n ' + _chalk2['default'].black.bgWhite('From ' + LiveData.station) + '  Last refresh: ' + (0, _moment2['default'])(LastRefresh).format('HH:mm:ss') + '\n- - - - - - - - - - - - - - - - - - - - - - - - - - -\n' + deps.join('') + ' - - - - - - - - - - - - - - - - - - - - - - - - - - -\n';
    })();
  } else {
    tmpl = '\n    Loading...\n    ';
  }
  (0, _logUpdate2['default'])(tmpl);
}, 100);