'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = create;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _iconvLite = require('iconv-lite');

var _iconvLite2 = _interopRequireDefault(_iconvLite);

var _parseTable = require('./parseTable');

var _parseTable2 = _interopRequireDefault(_parseTable);

function create(config, callback) {
  var LoadData = function LoadData() {
    _classCallCheck(this, LoadData);

    this.startStation = config.station;

    var RequestURI = ['https://', // protocol
    'www.mvg-live.de', // url
    '/ims/dfiStaticAuswahl.svc', // endpoint
    '?haltestelle=' + this.startStation, // station of interesst
    '&ubahn=checked', // look for subway
    '&bus=checked', // look for bus
    '&tram=checked', // look for tram
    '&sbahn=checked' // look for sbahn
    ].join('');

    (0, _request2['default'])({
      uri: RequestURI,
      encoding: null
    }, function (err, res, body) {
      if (err && res.statusCode !== 200) callback('Error: Had problems to connect to mvg-page', null);
      var DOM = _iconvLite2['default'].decode(new Buffer(body), "ISO-8859-1");
      callback(null, (0, _parseTable2['default'])(DOM));
    });
  };

  return new LoadData();
}

module.exports = exports['default'];