'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

exports['default'] = create;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function create(DOM) {
  var ParseTable = (function () {
    function ParseTable() {
      _classCallCheck(this, ParseTable);

      this.$ = undefined;
      this.length = 0;
      this.trips = 0;
      this.station = 'unknown';
      this.serverTime = '00:00';
      this.departures = [];

      this.$ = _cheerio2['default'].load(DOM);
      // let tramLines = ['20','17','12','18','16','19','15','25','21','22','28','27'];

      this.length = this.$('tr').length;
      this.trips = this.$('.rowOdd, .rowEven').length;
      this.station = this.$('.headerStationColumn').text();
      this.serverTime = this.$('.serverTimeColumn').text();
      this.departures = this.findByType('ubahn');
    }

    _createClass(ParseTable, [{
      key: 'findByType',
      value: function findByType(type) {
        var lines = [];
        var availableTypes = ['ubahn', 'bus', 'sbahn', 'tram'];
        if (availableTypes.indexOf(type) < 0) throw 'error: ' + type + ' is not available as mvg type';

        var that = this;

        this.$('.rowOdd, .rowEven').each(function () {
          lines.push({
            route: that.$(this).find('.lineColumn').text(),
            station: that.cleanStationTitle(that.$(this).find('.stationColumn').text()),
            arrivingIn: that.$(this).find('.inMinColumn').text()
          });
        });

        return lines;
      }
    }, {
      key: 'cleanStationTitle',
      value: function cleanStationTitle(title) {
        return title.replace(/^\s+|\s+$/g, '');
      }
    }]);

    return ParseTable;
  })();

  return new ParseTable();
}

module.exports = exports['default'];